/*
	Bill Rouady
	Netscape Communications, Inc.
	July, 1996
 */
import l3d.*;
import java.awt.*;
import java.applet.Applet;
import netscape.javascript.JSObject;

/**
 */
public class exampleObserver extends Applet implements Runnable, L3DObserver{

	L3DScene l3d;
	L3DObject cubeObject;

	float xPos = 0.0f;
	float yPos = 0.0f;
	float zPos = 0.0f;

	Label xValue = new Label("X = "+xPos, Label.CENTER);
	Label yValue = new Label("Y = "+yPos, Label.CENTER);
	Label zValue = new Label("Z = "+zPos, Label.CENTER);

	Thread observerThread;

    public void init() {

		setLayout(new GridLayout(1,3));

        xValue.setFont(new Font("Helvetica", Font.BOLD, 14));
        yValue.setFont(new Font("Helvetica", Font.BOLD, 14));
        zValue.setFont(new Font("Helvetica", Font.BOLD, 14));

		add("West", xValue);
		add("Center", yValue);
		add("East", zValue);

        l3d = (L3DScene)getDocument().getMember("l3d");
        while(cubeObject == null) {
        	cubeObject = l3d.getObject("testcube");
		}

        if (l3d != null) {
            l3d.advise(this, null, "onCameraMove") ;
            l3d.advise(this, null, "onMouseClick") ;
        }


    }

    public void start() {

		if(observerThread == null) {
	    	observerThread = new Thread(this);
	    	observerThread.start();
		}

    }

	public void run() {

		while(observerThread != null) {

		}
	}

	public void stop() {

		observerThread.stop();
		observerThread = null;

	}

	public void destroy() {

	}

	public int onMouseClick(L3DObject objectClicked) {

		System.out.println(objectClicked);
		System.out.println(cubeObject);
//		if(objectClicked == cubeObject) {
			cubeObject.setColor((float)(Math.random()),
								(float)(Math.random()),
								(float)(Math.random()));
			l3d.render();
//		}
        return 1 ;
    }

	public int onCameraMove(float [] matrix) {
        
		xValue.setText("X = "+matrix[12]);
		yValue.setText("Y = "+matrix[13]);
		zValue.setText("Z = "+matrix[14]);
        
        return 0 ;
    }

	public int onMouseMove(L3DObject object) {

	 	return 0;
	}

	public int onAnchorClick(L3DObject object, String value) {

	 	return 0;
	}

	public int onObjectAdded(L3DObject object) {

	 	return 0;
	}

	public int onSceneLoaded(L3DObject object) {

	 	return 0;
	}

	public int onStatusChange() {

	 	return 0;
	}

	public int onKeyDown() {

	 	return 0;
	}

	public int onKeyUp() {

	 	return 0;
	}

	public int onPopupMenu() {

	 	return 0;
	}

	public int onSelectionChange(L3DObject object) {

	 	return 0;
	}

	public int onEnter(L3DScene scene) {

	 	return 0;
	}

	public int onExit() {

	 	return 0;
	}



	public JSObject getDocument() {
		return (JSObject)JSObject.getWindow(this).getMember("document");
	}

}
    

